Skip to main content

Recursion - Medium Level - Question 1

Recursion - Medium Level - Question 1


Leetcode 50 Pow(x, n)

Implement pow(x, n), which calculates x raised to the power n (i.e., x^n).

Constraints:

-100.0 < x < 100.0

-2^31 <= n <= 2^31-1

-10^4 <= x^n <= 10^4


Analysis:

If n == 0, then it always return 1;

If n == 1, it returns x.

For other n, consider the positive n first (since the negative value can be calculated with the positive ones).

If n is even, then pow(x, n) can be rewritten as pow(x, n/2) * pow(x, n/2); if odd, pow(x, n/2) * pow(x, n/2) * x. One of the key steps is that we just need to calculate pow(x, n/2) once, for the rest calls (or the second time to this question), just re-use the calculated results.

One corner case is pow(x, INT_MIN), which will cause overflow if simply timing with (-1). Some details need to take.


See the code below:

class Solution {
public:
    double myPow(double x, int n) {
        // the nagative case (handled the corner case)
        if(n<0) return 1.0/(x*myPow(x, -(n+1)));
        // base case
        if(n==0) return 1;
        // only calculate once
        double t = myPow(x, n/2);
        if(n&1) return t*t*x;
        return t*t;
    }
};


Question 2

Leetcode 1922 Count Good Numbers

A digit string is good if the digits (0-indexed) at even indices are even and the digits at odd indices are prime (2, 3, 5, or 7).


For example, "2582" is good because the digits (2 and 8) at even positions are even and the digits (5 and 2) at odd positions are prime. However, "3245" is not good because 3 is at an even index but is not even.

Given an integer n, return the total number of good digit strings of length n. Since the answer may be large, return it modulo 10^9 + 7.


A digit string is a string consisting of digits 0 through 9 that may contain leading zeros.


Constraints:

1 <= n <= 10^15


Analysis:

One of the keys is how to keep the question still the "same question".

It is clear that for this question, the total number is "5 * 4 * 5 * 4 * 5 * 4 ...", which are apparently repetitive operations. So we do not need to calculate it one by one, which is NOT the most efficient method.

We can divide it into two parts: depending on its length, 

 if the first part is even, then the second part can always start with 5, or the same as the original question;

if the first part is odd, then the second part will start with 4, which is NOT the same as the original question. But we make it to the same: since we know it will start with 4, we can re-write it as 4 * (the remaining part), where the remaining part starts with 5 again.

Another key is to just calculate one for each length.


See the code below:


class Solution {
public:
    int countGoodNumbers(long long n) {
        int mod = 1e9 + 7;
        if(n==0) return 1;
        if(n==1) return 5;
        if(n==2) return 20;
        long d = n/2, t = 1;
        if(n&1) {
            t = countGoodNumbers(d);
            // n = 3, 7, ...
            if(d&1) return t*4*t%mod;
            // n = 5, 9, ...
            return t*5*t%mod;
        }
        if(d&1) {
            // n = 6, 10, ...
            t = countGoodNumbers(d-1);
            return t*5%mod*4*t%mod;
        }
        // n = 4, 8, ...
        t = countGoodNumbers(d);
        return t*t%mod;
    }
};

A different way to divide the n:

We can always to take the power of 2 as the first part, then it will always to be even (even after division by half). 

See the code below:


class Solution {
public:
    int countGoodNumbers(long long n) {
        if(n==0) return 1;
        if(n==1) return 5;
        if(n==2) return 20;
        // this line (or base case) is needed
        if(n==3) return 100;
        long mod = 1e9 + 7, s = pow(2, floor(log2(n)));
        long t = countGoodNumbers(s/2)%mod;
        long r = countGoodNumbers(n - s)%mod;
        return (t*t%mod)*r%mod;
    }
};
Please be noted that the above code may re-calculate some intermediate states, but it is till fast enough to coverge.


Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class